; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; ADC initialisieren mit "Free Run" und Vorteiler								
; 	ADEN: ADC Enable                             								
; 	ADSC: ADC Start Conversion                   								
; 	ADFR: ADC Free Running Select                								
; 	ADIF: ADC Interrzpt Flag                     								
; 	ADIE: ADC Interrupt Enable                   								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
;																				
;	ADPS2 ADPS1 ADPS0 Division Factor											
;	0 		0 	0 		2														
;	0 		0 	1 		2														
;	0 		1 	0 		4														
;	0 		1 	1 		8														
;	1 		0 	0 		16														
; *	1 		0 	1	 	32														
; 	1 		1 	0 		64														
;	1 		1 	1 		128														
;																					
; ADC REFERENZ																		
; REFS1 REFS0 Voltage Reference Selection											
;  0     0    AREF, Internal Vref turned off										
;  0     1    AVCC with external capacitor at AREF pin								
; *1     1    Internal 2.56V Voltage Reference with external capacitor at AREF pin	
;																					
;																					
; Takt mit einer Frequenz zwischen 50kHz und 200kHz, um die maximale Aulsung zu erreichen
;  VT	1 MHz	2 MHz	4 MHz	8 MHz	16 MHz										
;   2	38.462	76.923	153.846	307.692	615.385										
;   4	19.231	38.462	 76.923	153.846	307.692										
;   8	 9.615	19.231	 38.462	 76.923	153.846										
;  16	 4.808	 9.615	 19.231	 38.462	 76.923										
;  32	 2.404	 4.808	  9.615	 19.231	 38.462										
;  64	 1.202	 2.404	  4.808	  9.615	 19.231										
; 128	   601	 1.202	  2.404	  4.808	  9.615										
;																					
; Sampling=Takt/(13*VT)																

ADC_INITIALISIERUNG:
;	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADIE)|(0<<ADPS2)|(0<<ADPS1)|(0<<ADPS0)) ; (2) 
;	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADIE)|(0<<ADPS2)|(1<<ADPS1)|(0<<ADPS0)) ; (4)
	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADIE)|(0<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)) ; (8)
;	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADIE)|(1<<ADPS2)|(0<<ADPS1)|(0<<ADPS0)) ; (16)
;	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADIE)|(1<<ADPS2)|(0<<ADPS1)|(1<<ADPS0)) ; (32)
	out ADCSR, temp

	ldi temp, (1<<REFS1)|(1<<REFS0)|(1<<ADLAR)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0); ADC0
	out ADMUX, temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC0_TEMP:
	ldi temp, (1<<REFS1)|(1<<REFS0)|(1<<ADLAR)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0); ADC0
	out ADMUX, temp
;-------------------------------------------------------------------------------
ADC0_TEMP_w:
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt	
	rjmp ADC0_TEMP_w
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
;-------------------------------------------------------------------------------
ADC0_TEMP_w2:
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt	
	rjmp ADC0_TEMP_w2
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
;-------------------------------------------------------------------------------
	in  temp, ADCH 				; ADC							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC1_TEMP:
	ldi temp, (1<<REFS1)|(1<<REFS0)|(1<<ADLAR)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(1<<MUX0); ADC1
	out ADMUX, temp
;-------------------------------------------------------------------------------
ADC1_TEMP_w:
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt	
	rjmp ADC1_TEMP_w
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
;-------------------------------------------------------------------------------
ADC1_TEMP_w2:
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt	
	rjmp ADC1_TEMP_w2
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
;-------------------------------------------------------------------------------
	in  temp, ADCH 				; ADC							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADCi:

reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
