; ##############################################################################
; ##############################################################################
; ##############################################################################
;	Mode  WGM13   WGM12   WGM11   WGM10 	Timer/Counter   			TOP		Update of 	TOV1 Flag
;	 			 (CTC1)  (PWM11) (PWM10) Mode of Operation(1)  				OCR1x 		Set	on   
;	0 		0 	 	0 		0 		0 	Normal 						0xFFFF 	Immediate 	MAX		 
;	1 		0 		0 		0 		1 	PWM, Phase Correct, 8-bit 	0x00FF 	TOP 		BOTTOM 	 
;	2 		0 		0 		1 		0 	PWM, Phase Correct, 9-bit 	0x01FF 	TOP 		BOTTOM	 
;	3 		0 		0 		1 		1 	PWM, Phase Correct, 10-bit 	0x03FF 	TOP 		BOTTOM	 
;	4 		0 		1 		0 		0 	CTC 						OCR1A 	Immediate 	MAX		 
;*  5 		0 		1 		0 		1 	Fast PWM, 8-bit 			0x00FF 	TOP 		TOP		 
;	6 		0 		1 		1 		0 	Fast PWM, 9-bit 			0x01FF 	TOP 		TOP		 
;	7 		0 		1 		1 		1 	Fast PWM, 10-bit 			0x03FF 	TOP 		TOP		 
;	8 		1 		0 		0 		0 	PWM, Phase and Freq Correct ICR1 	BOTTOM 		BOTTOM	 
;	9 		1 		0 		0 		1 	PWM, Phase and Freq Correct OCR1A 	BOTTOM 		BOTTOM	 
;	10 		1 		0 		1 		0 	PWM, Phase Correct 			ICR1 	TOP 		BOTTOM	 
;	11 		1 		0 		1 		1 	PWM, Phase Correct 			OCR1A 	TOP 		BOTTOM	 
;	12 		1 		1 		0 		0 	CTC ICR1 							Immediate 	MAX		 
;	13 		1 		1 		0 		1 	(Reserved) 												 
;	14 		1 		1 		1 		0 	Fast PWM 					ICR1 	TOP 		TOP		 
;	15 		1 		1 		1 		1 	Fast PWM 					OCR1A 	TOP 		TOP		 
;																								
; BIT7-COM1A1- Compare Output Mode for channel A  												
; BIT6-COM1A0- Compare Output Mode for channel A  												
;*BIT5-COM1B1- Compare Output Mode for channel B  												
;*BIT4-COM1B0- Compare Output Mode for channel B  												
; BIT3-FOC1A - Force Output Compare for channel A 												
; BIT2-FOC1B - Force Output Compare for channel B 												
; BIT1-WGM11 - PWM-aus,  8-9-10-Bit-PWM			  												
;*BIT0-WGM10 - PWM-aus,  8-9-10-Bit-PWM           												
;	   WGM11 WGM10  Description	                  												
;		0     	0	PWM-aus                       												
;		0		1	 8 Bit PWM                    												
;		1		0	 9 Bit PWM                    												
;		1		1	10 Bit PWM                    												
;																									
; BIT7-ICNC1 Input Capture Noise Canceler															
; BIT6-ICES1 Input Capture Edge Select																
; BIT5- -    																						
; BIT4-WGM13 Waveform Generation Mode																
;*BIT3-WGM12 Waveform Generation Mode																
; BIT2-CS12  Clock Select																			
; BIT1-CS11  Clock Select																			
;*BIT0-CS10  Clock Select																			
;	 CS12 CS11 CS10 Description																		
;		0	0 	0 	No clock source. (Timer/Counter stopped)										
;		0	0 	1 	clkI/O/1 (No prescaling)														
;		0	1 	0 	clkI/O/8 (From prescaler)														
;		0	1 	1 	clkI/O/64 (From prescaler)														
;		1	0 	0 	clkI/O/256 (From prescaler)														
;		1	0 	1 	clkI/O/1024 (From prescaler)													
;		1	1 	0 	External clock source on T1 pin. Clock on falling edge.										
;		1	1 	1 	External clock source on T1 pin. Clock on rising edge.        										
TIMER1_PWM:
	ldi     temp,(1<<COM1A0)|(1<<COM1A1)|(0<<COM1B0)|(1<<COM1B1)|(0<<WGM11)|(1<<WGM10)
	out     TCCR1A,temp              
	ldi     temp,(1<<WGM12)|(0<<CS12)|(0<<CS11)|(1<<CS10)
	out     TCCR1B,temp   

	ldi temp,(255/2)
	out OCR1BL,temp
	out OCR1AL,temp



	sbi DDRB,1 ; PORT B initoalisieren
    sbi DDRB,2 		 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
